const ALLOW = 0;
const WARN = 1;
const ERROR = 2;

module.exports = {
  "env": {
    "browser": false,
    "es6": true,
    "node": true
  },
  "extends": "eslint:recommended",
  "parserOptions": {
    "ecmaVersion": 2018,
    "sourceType": "module"
  },
  "rules": {
    "no-constant-condition": WARN,
    "valid-typeof": ALLOW,
    "max-len": [WARN, { "code": 100 }],
    "no-console": [ERROR, { "allow": ["warn", "error"] }],
    "no-restricted-syntax": [ERROR, "ClassDeclaration"],
    "comma-dangle": [ERROR,"never"],
    "block-scoped-var": WARN,
    "curly": [ERROR,"all"],
    "default-case": ERROR,
    "dot-notation": ERROR,
    "eqeqeq": ERROR,
    "guard-for-in": WARN,
    "no-alert": ERROR,
    "no-caller": ERROR,
    "no-div-regex": ERROR,
    "no-else-return": ERROR,
    "no-eq-null": ERROR,
    "no-eval": ERROR,
    "no-extra-bind": ERROR,
    "no-fallthrough": ERROR,
    "no-floating-decimal": ERROR,
    "no-implicit-coercion": [ERROR,{"boolean":true,"number":true,"string":true}],
    "no-implied-eval": ERROR,
    "no-invalid-this": ERROR,
    "no-iterator": ERROR,
    "no-labels": ERROR,
    "no-lone-blocks": ERROR,
    "no-loop-func": ERROR,
    "no-multi-spaces": ERROR,
    "no-multi-str": ERROR,
    "no-native-reassign": ERROR,
    "no-new-func": ERROR,
    "no-new-wrappers": ERROR,
    "no-new": ERROR,
    "no-octal-escape": ERROR,
    "no-octal": ERROR,
    "no-process-env": WARN,
    "no-proto": ERROR,
    "no-redeclare": [ERROR,{"builtinGlobals":true}],
    "no-return-assign": [ERROR,"always"],
    "no-script-url": ERROR,
    "no-self-compare": ERROR,
    "no-sequences": ERROR,
    "no-unused-expressions": ERROR,
    "no-useless-call": ERROR,
    "no-void": ERROR,
    "no-with": ERROR,
    "radix": ERROR,
    "wrap-iife": [ERROR,"outside"],
    "no-catch-shadow": ERROR,
    "no-delete-var": ERROR,
    "no-shadow-restricted-names": ERROR,
    "no-shadow": [ERROR,{"hoist":"all"}],
    "no-undef": ERROR,
    "no-unused-vars": WARN,
    "no-use-before-define": ERROR,
    "array-bracket-spacing": [WARN,"never",{}],
    "brace-style": [ERROR,"1tbs",{}],
    "comma-spacing": [ERROR,{"after":true}],
    "comma-style": [ERROR],
    "eol-last": ERROR,
    "func-style": [ERROR,"declaration"],
    "indent": [2,2],
    "linebreak-style": [ERROR,"unix"],
    "no-continue": ERROR,
    "no-inline-comments": ERROR,
    "no-lonely-if": ERROR,
    "no-new-object": ERROR,
    "no-spaced-func": WARN,
    "no-trailing-spaces": ERROR,
    "no-unneeded-ternary": ERROR,
    "object-curly-spacing": [WARN,"always",{}],
    "operator-assignment": [ERROR,"always"],
    "operator-linebreak": [ERROR,"before"],
    "quotes": [ERROR,"double"],
    "semi": [ERROR,"always"],
    "space-in-parens": [WARN,"never",{}],
    "space-infix-ops": ERROR,
    "space-unary-ops": ERROR,
    "wrap-regex": WARN,
    "no-var": ERROR,
    "object-shorthand": [ERROR,"always"],
    "prefer-const": WARN,
    "prefer-spread": WARN,
    "no-bitwise": WARN,
    "no-plusplus": WARN
  }
};
